#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
using namespace std;

inline char simb( unsigned val ) {
   return val < 10 ? '0' + val : 'A' + val - 10;
}

ostream& operator << ( ostream& stream, // только для отладки
                       vector<unsigned>& obj ) {
   stream << "{[" <<  obj.size() << "]: ";
   for( vector<unsigned>::iterator i = obj.begin(); i != obj.end(); i++ )
      stream << *i << ( i + 1 != obj.end() ? ", " : " " ); 
   return stream << "}";
};

int main( int argc, char **argv ) {
   bool debug = ( argc > 1 && 
                  ( ( string( argv[ 1 ] ) == "-v" ) ||
                    ( string( argv[ 1 ] ) == "debug" )
                ) );
   while( true ) {
      unsigned metr, ch, zn;
      cout << "система счисления: ";
      cin >> metr;
      cout << "числитель (1...)?: ";
      cin >> ch;
      cout << "знаменатель (" << ch + 1 << "...)?: ";
      cin >> zn;
      if( ch >= zn ) {
         cout << "должнв быть правльная дробь!" << endl;
         continue;
      }
      string sval;
      vector<unsigned> list;
      unsigned ost = ch;
      while( true ) {
         if( sval.empty() ) sval = "0."; 
         else sval.push_back( simb( ost / zn ) );
         ost %= zn;
         if( debug ) cout << setw( 3 ) << ost << " -> " << list << endl;
         if( 0 == ost ) break;
         vector<unsigned>::iterator it = find( list.begin(), list.end(), ost );
         if( it == list.end() ) 
            list.push_back( ost );
         else {
            ost = list.end() - it;
            break; 
         }
         ost *= metr;
      };
      if( ost != 0 ) { // периодическая дробь, ost - период
         string::iterator is = sval.end() - ost;
         sval.insert( is, '(' );
         sval += ")";
      }
      cout << "длина периода " << ost << " : "
           << ch << " / " << zn << " = " << sval << endl;
   }
}
