#include <iostream>
#include <sstream>
#include <vector>
using namespace std;

class matrix {
private:
   double **data;
   bool ok;
   unsigned rows, // 1-й индекс
            cols; // 2-й тндекс
protected:
   void clean( void ) {
      for( unsigned r = 0; r < rows; r++ )
         delete [] data[ r ];
      delete [] data;
      cols = rows = 0;
   }
public:
   bool inline good( void ) { return ok; }
   const int col( void ) { return cols; }
   const int row( void ) { return rows; }
   matrix( unsigned rows, unsigned cols ) {
      ok = true;
      this->cols = cols;
      this->rows = rows;
      data = new double*[ rows ];
      for( unsigned r = 0; r < rows; r++ )
         data[ r ] = new double[ cols ];
   }
   matrix( const matrix& m ) {
      if( !( ok = m.ok ) ) return;
      data = new double*[ rows = m.rows ];
      cols = m.cols;
      for( unsigned r = 0; r < rows; r++ )
         data[ r ] = new double[ cols ];
      for( unsigned r = 0; r < rows; r++ ) 
         for( unsigned c = 0; c < cols; c++ ) 
            data[ r ][ c ] = m.data[ r ][ c ];
   }
   ~matrix( void ) { clean(); }
   double* operator []( int row ) { return data[ row ]; }

   matrix& operator =( const matrix& m ) {
      if( !( ok = m.ok ) ) return *this;
      clean();
      data = new double*[ rows = m.rows ];
      cols = m.cols;
      for( unsigned r = 0; r < rows; r++ )
         data[ r ] = new double[ cols ];
      for( unsigned r = 0; r < rows; r++ ) 
         for( unsigned c = 0; c < cols; c++ ) 
            data[ r ][ c ] = m.data[ r ][ c ];
      return *this;
   }
   friend ostream& operator <<( ostream& out, matrix& obj ) {
      if( !obj.ok ) 
         return out << "разрушенный объект" << endl;
      for( unsigned r = 0; r < obj.rows; r++ ) 
         for( unsigned c = 0; c < obj.cols; c++ ) 
            out << obj.data[ r ][ c ] << ( c == obj.cols - 1 ? "\n" : ", " );
      return out; 
   }
   friend istream& operator >>( istream& inp, matrix& obj );
};

istream& operator >>( istream& inp, matrix& obj ) {
   obj.clean();
   unsigned r = 0;
   vector<double> l;
   while( true ) {
      string e;
      getline( inp, e );
      if( 0 == e.length() ) break;
      istringstream ist( e );
      unsigned n = 0;
      try {
         double d;
         while( ist >> d ) {
            n++;
            l.push_back( d );
         }
      }
      catch( exception const& e ) {
         obj.ok = false;
         return inp;
      }
      if( 0 == r ) obj.cols = n;
      else if( obj.cols != n ) {
         obj.ok = false;
         return inp;
      }
      r++;
   }
   obj.data = new double*[ ( obj.rows = r ) ];
   for( r = 0; r < obj.rows; r++ ) {
      obj.data[ r ] = new double[ obj.cols ];
      for( unsigned c = 0; c < obj.cols; c++ )
      obj.data[ r ][ c ] = l[ r * obj.cols + c ];
   }
   obj.ok = true;
   return inp;
};

#include "main.c"
