#include <iostream>
#include <sstream>
#include <vector>
using namespace std;

typedef vector<double> line;
ostream& operator <<( ostream& out, line& obj ) {
   for( unsigned i = 0; i < obj.size(); i++ )
      out << obj[ i ] << ( i == obj.size() - 1 ? "" : ", " );
   return out;
}

typedef vector<line> table;

class matrix : protected vector< vector<double> > {
private:
   bool ok;
   unsigned rows, // 1-й индекс
            cols; // 2-й индекс
   void clean( void ) {
      for( unsigned r = 0; r < rows; r++ ) (*this)[ r ].clear();
      (*this).clear();
   }
public:
   bool inline good( void ) { return ok; }
   const int col( void ) { return cols; }
   const int row( void ) { return rows; }
   matrix( unsigned rows, unsigned cols ) {
      this->rows = rows;
      this->cols = cols;
      line l( cols, 0.0 );
      for( unsigned r = 0; r < rows; r++ )
         (*this).push_back( l );
   }
   matrix( const matrix& m ) {
      if( !( ok = m.ok ) ) return;
      rows = m.rows;
      cols = m.cols;
      for( unsigned r = 0; r < rows; r++ )
         push_back( ( (table)m )[ r ] );
   }
   ~matrix( void ) { clean(); }
   line& operator []( unsigned row ) { return (*(table*)this)[ row ]; }
   matrix& operator =( const matrix& m ) {
      if( !( ok = m.ok ) ) return *this;
      clean();
      rows = m.rows;
      cols = m.cols;
      for( unsigned r = 0; r < rows; r++ )
         push_back( ( (table)m )[ r ] );
      return *this;
   }
   friend ostream& operator <<( ostream& out, matrix& obj ) {
      for( unsigned r = 0; r < obj.rows; r++ ) 
         out << ( (table)obj )[ r ] << endl;
      return out; 
   }
   friend istream& operator >>( istream& inp, matrix& obj );
};

istream& operator >>( istream& inp, matrix& obj ) {
   obj.clean();
   int r = 0;
   while( true ) {
      string e;
      getline( inp, e );
      if( 0 == e.length() ) break;
      istringstream ist( e );
      int n = 0;
      vector<double> l;
      try {
         double d;
         while( ist >> d ) {
            n++;
            l.push_back( d );
         }
      }
      catch( exception const& e ) {
         obj.ok = false;
         return inp;
      }
      if( 0 == r ) obj.cols = l.size();
      else if( obj.cols != l.size() ) {
         obj.ok = false;
         return inp;
      }
      obj.push_back( l );
      r++;
   }
   obj.rows = r;
   obj.ok = true;
   return inp;
};

#include "main.c"
 
