#include <iostream>
#include <sstream>
#include <vector>

using namespace std;

class matrix {
public:
   double *data;  // масив [ rows * cols ]
private:
   bool ok;
   unsigned rows, // 1-й индекс
            cols; // 2-й тндекс
protected:
   void clean( void ) {
      delete [] data;
      cols = rows = 0;
   }
public:
   bool inline good( void ) { return ok; }
   const int col( void ) { return cols; }
   const int row( void ) { return rows; }
   matrix( int rows, int cols ) {
      ok = true;
      this->cols = cols;
      this->rows = rows;
      data = new double[ rows * cols ];
   }
   matrix( const matrix& m ) {
      if( !( ok = m.ok ) ) return;
      data = new double[ ( rows = m.rows ) * ( cols = m.cols ) ];
      for( unsigned long long i = 0; i < rows * cols; i++ )
         data[ i ] = m.data[ i ];
   }
   ~matrix( void ) { clean(); }
   double* operator []( int row ) { 
      return data + row * cols;
   }
   matrix& operator =( const matrix& m ) {
      if( !( ok = m.ok ) ) return *this;
      clean();
      data = new double[ ( rows = m.rows ) * ( cols = m.cols ) ];
      for( unsigned long long i = 0; i < rows * cols; i++ )
         data[ i ] = m.data[ i ];
      return *this;
   }
   friend ostream& operator <<( ostream& out, matrix& obj ) {
      if( !obj.ok ) 
         return out << "разрушенный объект" << endl;
      for( unsigned r = 0; r < obj.rows; r++ ) 
         for( unsigned c = 0; c < obj.cols; c++ ) 
            out << obj.data[ r * obj.cols +  c ] << ( c == obj.cols - 1 ? "\n" : ", " );
      return out; 
   }
   friend istream& operator >>( istream& inp, matrix& obj );
};

istream& operator >>( istream& inp, matrix& obj ) {
   obj.clean();
   unsigned r = 0;
   vector<double> l;
   while( true ) {
      string e;
      getline( inp, e );
      if( 0 == e.length() ) break;
      istringstream ist( e );
      unsigned n = 0;
      try { 
         double d;   
         while( ist >> d ) {
            n++;
            l.push_back( d );
         }
      }
      catch( exception const& e ) {
         obj.ok = false;
         return inp;
      }
      if( 0 == r ) obj.cols = n;
      else if( obj.cols != n ) {
         obj.ok = false;
         return inp;
      }
      r++;
   }
   obj.data = new double[ ( obj.rows = r ) * obj.cols ];
   for( unsigned long long i = 0; i < obj.rows * obj.cols; i++ )
      obj.data[ i ] = l[ i ];
   obj.ok = true; 
   return inp; 
};

#include "main.c"
