#include <iostream>
#include <sstream>
#include <vector>

using namespace std;

typedef vector<double> line;
ostream& operator <<( ostream& out, line& obj ) {
   for( unsigned i = 0; i < obj.size(); i++ ) 
      out << obj[ i ] << ( i == obj.size() - 1 ? "" : ", " );
   return out;
}

class matrix {
private:
   typedef vector<line> table;
   vector< vector<double> > *data;
   bool ok;
   unsigned rows, // 1-й индекс
            cols; // 2-й индекс
   void clean( void ) {
      for( unsigned r = 0; r < rows; r++ ) (*data)[ r ].clear();
      (*data).clear();
   }
public:
   bool inline good( void ) { return ok; }
   const int col( void ) { return cols; }
   const int row( void ) { return rows; }
   matrix( void ) {
      ok = true;
      cols = rows = 0;
      data = new table();      
   }
   matrix( int rows, int cols ) {
      ok = true;
      this->cols = cols;
      this->rows = rows;
      line l( cols, 0.0 );      
      data = new table( rows, l );      
   }
   matrix( const matrix& m ) {
      if( !( ok = m.ok ) ) return;
      data = new table();      
      cols = m.cols;
      rows = m.rows;
      for( unsigned r = 0; r < rows; r++ )
         data->push_back( (*m.data)[ r ] );
   }
   ~matrix( void ) {
      clean();
      delete data;
   }
   line& operator []( int row ) { return (*data)[ row ]; }
   matrix& operator =( const matrix& m ) {
      if( !( ok = m.ok ) ) return *this;
      clean();
      cols = m.cols;
      rows = m.rows;
      for( unsigned r = 0; r < rows; r++ ) 
         data->push_back( (*m.data)[ r ] );
      return *this;
   } 
   inline void clear( void ) {
      clean();
      cols = rows = 0;
   }
   friend ostream& operator <<( ostream& out, matrix& obj ) {
      if( !obj.ok ) 
         return out << "разрушенный объект" << endl;
      for( unsigned r = 0; r < obj.rows; r++ ) 
         out << (*(obj.data))[ r ] << endl; 
      return out; 
   }
   friend istream& operator >>( istream& inp, matrix& obj );
};

istream& operator >>( istream& inp, matrix& obj ) {
   obj.clear();
   int r = 0;
   while( true ) {
      string e;
      getline( inp, e );
      if( 0 == e.length() ) break;
      istringstream ist( e );
      int n = 0;
      vector<double> l;
      try { 
         double d;   
         while( ist >> d ) {
            n++;
            l.push_back( d );
         }
      }
      catch( exception const& e ) {
         obj.ok = false;
         return inp;
      }
      if( 0 == r ) obj.cols = l.size();
      else if( obj.cols != l.size() ) {
         obj.ok = false;
         return inp;
      }
      obj.data->push_back( l );
      r++;
   }
   obj.rows = r;
   obj.ok = true;
   return inp;
};

#include "main.c"
